#include "IrrCompileConfig.h"

#ifdef _IRR_COMPILE_WITH_X11_DEVICE_

#ifdef _IRR_COMPILE_WITH_OPENGL_

#include "COpenGLContextLinux.h"
#include "CRenderWindowLinux.h"
#include "COpenGLUtils.h"
#include "os.h"



namespace irr
{
namespace video
{

//
COpenGLContextLinux::COpenGLContextLinux(
                                         COpenGLDriver* driver,
                                        const SVideoContextConfig& contextConfig,
                                         Display* display,
                                         GLXContext ctx,
                                         GLXDrawable glxDrawable,
                                         bool externalContext
                                         ) :
        IOpenGLContext( driver, contextConfig, externalContext )
        , glxContext(ctx)
        , X11Display(display)
        , Drawable(glxDrawable)
    {
        //
    }



COpenGLContextLinux::~COpenGLContextLinux()
{

//		if (Context)
//		{
//			if (glxWindow)
//			{
//				if (!glXMakeContextCurrent(display, None, None, NULL))
//					os::Printer::log("Could not release glx context.", ELL_WARNING);
//			}
//			else
//			{
//				if (!glXMakeCurrent(display, None, NULL))
//					os::Printer::log("Could not release glx context.", ELL_WARNING);
//			}
//
//		}

}

/** See GLContext */
bool COpenGLContextLinux::setTarget(void *videoData)
{
    // la le probleme c'est qu'on recoit un linux Handle
    SRenderWindowLinuxHandle* handle = reinterpret_cast<SRenderWindowLinuxHandle*>(videoData);



    if(!handle)
    {
        os::Printer::log("No drawable video data",ELL_ERROR);
        return false;
    }


//    GLXDrawable glxDrawable //= reinterpret_cast<GLXDrawable>(videoData);

//    Drawable = glxDrawable;
    Drawable = handle->WindowId;
//    return glXMakeCurrent(
//                (Display*)videoData.OpenGLLinux.X11Display, videoData.OpenGLLinux.X11Window, (GLXContext)videoData.OpenGLLinux.X11Context
//                )
    // read then write drawables

//    return (glXMakeContextCurrent(X11Display, Drawable, Drawable, glxContext));
    return (glXMakeContextCurrent( handle->X11Connection, Drawable, Drawable, glxContext));
}


bool COpenGLContextLinux::isCompatibleWithRenderWindow(IRenderWindow* ) const
{
    //!
    return false;
}

// swapBuffers
bool
COpenGLContextLinux::swapBuffers()
{
//    GLXDrawable Drawable;
//    Drawable = glXGetCurrentDrawable();

    glXSwapBuffers(X11Display, Drawable);
    return false;
}



/** See GLContext */
//bool COpenGLContextLinux::endCurrent()
//{
//    return (glXMakeContextCurrent(X11Display, None, None, NULL));
////    return wglMakeCurrent((HDC)0, (HGLRC)0) != 0;
//}


void COpenGLContextLinux::releaseContext()
{
    // should check if external window
    glXDestroyContext(X11Display, glxContext);
//    if (glxWindow)
//        glXDestroyWindow(X11Display, glxWindow);
}



} // video
} // irr

#endif // #ifdef _IRR_COMPILE_WITH_OPENGL_

#endif // _IRR_COMPILE_WITH_X11_DEVICE_
