#include "IrrCompileConfig.h"



#ifdef _IRR_COMPILE_WITH_WINDOWS_DEVICE_
#ifdef _IRR_COMPILE_WITH_SOFTWARE_

#include "IImage.h"
#include "ISoftwareContextWin32.h"
#include "irrString.h"
#include "os.h"

namespace irr
{

namespace video
{

ISoftwareContextWin32::ISoftwareContextWin32(HDC hdc) :
    DeviceContext(hdc)
    {
//        _IRR_DEBUG_BREAK_IF( DeviceContext == 0);
    }


ISoftwareContextWin32::~ISoftwareContextWin32()
{

}

bool ISoftwareContextWin32::setDeviceContext( HDC temp )
//bool ISoftwareContextWin32::setTarget( void* data)
{
    // HDC
//    HWND temp = reinterpret_cast<HWND>(data);
//    if( temp )
//    {
//        WindowHandle = temp;
//        return true;
//    }


//    HDC temp = reinterpret_cast<HDC>(data);
    if( temp )
    {
        DeviceContext = temp;
        return true;
    }



    return false;
}


// TODO suppr l'image
bool ISoftwareContextWin32::displayImage(IImage* image, core::rect<s32>* src)
{

//    _IRR_DEBUG_BREAK_IF( BackBuffer == 0);
    _IRR_DEBUG_BREAK_IF( DeviceContext == 0);

    // TODO getBackBuffer ?
//     = BackBuffer;

//	HDC dc = GetDC( WindowHandle );
//    HWND windowHandle = WindowFromDC(DeviceContext);

	HDC dc = DeviceContext;

	if ( dc )
	{
//		RECT rect;
//		GetClientRect(windowHandle, &rect);

		const void* memory = (const void *)image->lock();

		BITMAPV4HEADER bi;
		ZeroMemory (&bi, sizeof(bi));
		bi.bV4Size = sizeof(BITMAPINFOHEADER);
		bi.bV4BitCount = (WORD)image->getBitsPerPixel();
		bi.bV4Planes = 1;
		bi.bV4Width = image->getDimension().Width;
		// possible bug here (see comments here http://msdn.microsoft.com/en-us/library/windows/desktop/dd145121%28v=vs.85%29.aspx )
		bi.bV4Height = -((s32)image->getDimension().Height);
		bi.bV4V4Compression = BI_BITFIELDS;
		bi.bV4AlphaMask = image->getAlphaMask();
		bi.bV4RedMask = image->getRedMask();
		bi.bV4GreenMask = image->getGreenMask();
		bi.bV4BlueMask = image->getBlueMask();

//        core::rect<s32> srcRect;
        core::dimension2di dims;
        core::dimension2di topLeft;
        int ret = 0;
		if ( src )
		{
//            topLeft =
//            dims =

//			ret = StretchDIBits(dc, 0,0,
//                 rect.right, rect.bottom,
//
//					src->UpperLeftCorner.X, src->UpperLeftCorner.Y,
//					src->getWidth(), src->getHeight(),
//					memory, (const BITMAPINFO*)(&bi), DIB_RGB_COLORS, SRCCOPY);
		}
		else
		{
		    //if the function succeeds, the return value is the number of scan lines copied. Note that this value can be negative for mirrored content.
			ret = StretchDIBits(dc,
                 0,
                 0,   //!< Destination rectangle, upper left (logical units)
//                 rect.right, rect.bottom,   //!< with/height ?
                image->getDimension().Width,
                image->getDimension().Height,  //!< bottom -right

                0, 0,   //!< Source rectangle
                image->getDimension().Width,
                image->getDimension().Height,
                memory,
                (const BITMAPINFO*)(&bi),
                DIB_RGB_COLORS,     //!<
                SRCCOPY             //!< Copies the source rectangle directly to the destination rectangle.
                );
		}

        core::stringc msg;
        if( GDI_ERROR == ret )
        {
            os::Printer::log( "GDI error", ELL_ERROR );
        }

//        os::Printer::log( "", ELL_INFORMATION);

		image->unlock();

		ReleaseDC( WindowFromDC(dc), dc);
	}
	return true;
}



} // video
} // irr

#endif // _IRR_COMPILE_WITH_SOFTWARE
#endif // _IRR_COMPILE_WITH_WINDOWS_DEVICE_

